(*
    ===========================================================================

    AboutBox

    ---------------------------------------------------------------------------

    2003/12/02  C

    ===========================================================================
*)
unit Info;

interface

uses
  Windows, SysUtils, Classes, Forms, StdCtrls, Controls, Buttons, ExtCtrls;

type
  TInfoForm = class(TForm)
    Panel1: TPanel;
    Panel3: TPanel;
    lblMail: TLabel;
    lblURL: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    lblExeName: TLabel;
    lblComment: TLabel;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure lblURLClick(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private

  public

  end;

procedure   OpenInfoForm();

implementation

uses
    iShare;

{$R *.dfm}

(*
    ===========================================================================
    OJ
    ===========================================================================
*)
procedure   OpenInfoForm();
var
    InfoForm: TInfoForm;
begin
    InfoForm := TInfoForm.Create(Application);
    try
        InfoForm.ShowModal();
    finally
        InfoForm.Free;
    end;
end;

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure TInfoForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title;
    lblExeName.Caption := ExtractFileName(ParamStr(0));
end;

(*
    ===========================================================================
    z[y[WN
    ===========================================================================
*)
procedure TInfoForm.lblURLClick(Sender: TObject);
begin
    SimpleShellExecute(lblURL.Caption);
end;

(*
    ===========================================================================
    [[N
    ===========================================================================
*)
procedure TInfoForm.lblMailClick(Sender: TObject);
begin
    SimpleShellExecute(Format('MailTo:%s?subject=from [%s] user', [lblMail.Caption, ExtractFileName(ParamStr(0))]));
end;

(*
    ===========================================================================
    ESCŏI
    ===========================================================================
*)
procedure TInfoForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = VK_ESCAPE then Self.Close;
end;

(*
    ===========================================================================
    OKŏI
    ===========================================================================
*)
procedure TInfoForm.BitBtn1Click(Sender: TObject);
begin
    Self.Close;
end;

(*
    ===========================================================================
    ACR`
    ===========================================================================
*)
procedure TInfoForm.PaintBox1Paint(Sender: TObject);
begin
    DrawIcon(PaintBox1.Canvas.Handle, 0, 0, Application.Icon.Handle);
end;

end.
