(*
    ===========================================================================

    EXEQɂċʂŎgp郂m

    ===========================================================================
*)

unit iShare;

interface

uses
    Windows, SysUtils, Forms, IniFiles, Variants, ShlObj, ShellApi, ActiveX, ComObj;

type
    //  ݒpR[h
    TClickConfig = packed record
        DeskTop    : string;
        MyComputer : string;
        MyNetwork  : string;
        Wait4Check  : Word;
        Wait4OK     : Word;
        Wait4Cabinet: Word;
        Wait4Explore: Word;
    end;

//  Ǎ
procedure   LoadConfiguration();
//  
procedure   SaveConfiguration();
//  fXNgbṽpX
function    GetDeskTopPath():string;
//  X^[gAbṽpX
function    GetStartUpPath(): string;
//  EBhE֘A
function    GetClassNameStr(WH: HWND): string;
function    GetWindowTextStr(WH: HWND): string;
function    IsTopLevelWindow(WH: HWND): Boolean;
function    GetMostTopLevelWindow(hWindow:HWND):HWND;
//  ̑
procedure   SimpleShellExecute(const FileName: string);
function    SendShortCutToStartUp(AFilePath: string): string;
procedure   OpenStartUp();
function    SendShortCutToDesktop(AFilePath: string): string;
procedure   ToggleDesktopNearly();
procedure   SendToRecycleBin(FileName: string);

var
    //  ݒe
    ClickConfig: TClickConfig;

implementation

//  ݒl̊l
const
    _DESKTOP    = '/desktop/fXNgbv/';
    _MYCOMPUTER = '/my computer/}C Rs[^/Arbeitsplatz/';
    _MYNETWORK  = '/Network Neighborhood/}C lbg[N/Netzwerkumgebung/';

    _WAIT_4_CHECK   = 300;
    _WAIT_4_OK      = 20;
    _WAIT_4_CABINET = 100;
    _WAIT_4_EXPLORE = 100;

//  INIt@C̃ZNV
const
    SEC_CLICK_HERE = 'ClickHere';

(*
    ===========================================================================
    ShellExecutebp[
    ===========================================================================
*)
procedure   SimpleShellExecute(const FileName: string);
begin
    try
        ShellExecute(0, nil, PChar(FileName), nil, nil, SW_SHOW);
    except
        ;
    end;
end;

(*
    ===========================================================================
    Ǎ
    ===========================================================================
*)
procedure   LoadConfiguration();
var
    IniFile: TIniFile;
begin
    IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
    try
        //  AhXݒ
        ClickConfig.DeskTop     := IniFile.ReadString (SEC_CLICK_HERE, 'Desktop'      , _DESKTOP);
        ClickConfig.MyComputer  := IniFile.ReadString (SEC_CLICK_HERE, 'MyComputer'   , _MYCOMPUTER);
        ClickConfig.MyNetwork   := IniFile.ReadString (SEC_CLICK_HERE, 'MyNetwork'    , _MYNETWORK);
        //  ҂Ԑݒ
        ClickConfig.Wait4Check   := IniFile.ReadInteger(SEC_CLICK_HERE, 'Wait4Check'  , _WAIT_4_CHECK);
        ClickConfig.Wait4OK      := IniFile.ReadInteger(SEC_CLICK_HERE, 'Wait4OK'     , _WAIT_4_OK);
        ClickConfig.Wait4Cabinet := IniFile.ReadInteger(SEC_CLICK_HERE, 'Wait4Cabinet', _WAIT_4_CABINET);
        ClickConfig.Wait4Explore := IniFile.ReadInteger(SEC_CLICK_HERE, 'Wait4Explore', _WAIT_4_EXPLORE);
    finally
        IniFile.Free;
    end;
end;

(*
    ===========================================================================
    
    ===========================================================================
*)
procedure   SaveConfiguration();
var
    IniFile: TIniFile;
begin
    IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
    try
        //  AhXݒ
        IniFile.WriteString (SEC_CLICK_HERE, 'Desktop'     , ClickConfig.DeskTop);
        IniFile.WriteString (SEC_CLICK_HERE, 'MyComputer'  , ClickConfig.MyComputer);
        IniFile.WriteString (SEC_CLICK_HERE, 'MyNetwork'   , ClickConfig.MyNetwork);
        //  ҂Ԑݒ
        IniFile.WriteInteger(SEC_CLICK_HERE, 'Wait4Check'  , ClickConfig.Wait4Check);
        IniFile.WriteInteger(SEC_CLICK_HERE, 'Wait4OK'     , ClickConfig.Wait4OK);
        IniFile.WriteInteger(SEC_CLICK_HERE, 'Wait4Cabinet', ClickConfig.Wait4Cabinet);
        IniFile.WriteInteger(SEC_CLICK_HERE, 'Wait4Explore', ClickConfig.Wait4Explore);
    finally
        IniFile.Free;
    end;
end;

(*
    ===========================================================================
    fXNgbvpX擾
    ---------------------------------------------------------------------------
    http://homepage1.nifty.com/MADIA/delphi/Win32API/ShFolder.htm
    http://homepage2.nifty.com/Mr_XRAY/Delphi/plFileDialog/B_BrowseFolder.htm
    http://ww4.tiki.ne.jp/~yonyon/programing/delphi/tips/tips-file.htm
    http://www.geocities.co.jp/SiliconValley-Cupertino/5872/Program/Shell/SHGetSpecialFolderLocation.html
    ===========================================================================
*)
function    GetDeskTopPath(): string;
var
    Root : PItemIDList;
    Buffer: array[0..MAX_PATH] of char;
begin
    Result := '';
    //  tH_̈ʒu擾
    if (NO_ERROR = SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, Root)) then
    begin
        //  ItemIDList\̂pXo
        SHGetPathFromIDList(Root, Buffer);
        Result := Buffer;
    end;
end;

(*
    ===========================================================================
    X^[gAbvpX
    ===========================================================================
*)
function    GetStartUpPath(): string;
var
    Root : PItemIDList;
    Buffer: array[0..MAX_PATH] of char;
begin
    Result := '';
    //  tH_̈ʒu擾
    if (NO_ERROR = SHGetSpecialFolderLocation(0, CSIDL_STARTUP, Root)) then
    begin
        //  ItemIDList\̂pXo
        SHGetPathFromIDList(Root, Buffer);
        Result := Buffer;
    end;
end;

(*
    =================================================================
    NX
    =================================================================
*)
function    GetClassNameStr(WH: HWND): string;
var
    WinClass: array[0..1024]of char;
begin
    GetClassName(WH, WinClass, 256);
    Result := WinClass;
end;

(*
    =================================================================
    ^Cgo[̃eLXg
    =================================================================
*)
function    GetWindowTextStr(WH: HWND): string;
var
    WinText: array[0..1024]of char;
begin
    GetWindowText(WH, WinText, 256);
    Result := WinText;
end;

(*
    =================================================================
    ̃EBhEgbvxEBhEǂ
    -----------------------------------------------------------------
    http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-3
    =================================================================
*)
function    IsTopLevelWindow(WH: HWND): Boolean;
begin
    Result := (GetParent(WH) = 0);
end;

(*
    =================================================================
    ̃EBhËԂ̐eEBhE
    -----------------------------------------------------------------
    http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-3
    =================================================================
*)
function GetMostTopLevelWindow(hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;

(*
    =================================================================
    X^[gAbvɓo^
    -----------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    =================================================================
*)
function    SendShortCutToStartUp(AFilePath: string): string;
var
    TargetPath: string;
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    FileName: String;
    LinkFileName: string;
    WFileName: WideString;
begin
    //  pX擾
    TargetPath := GetStartUpPath();
    //  v?
    Result := '';
    if (not DirectoryExists(TargetPath)) then Exit;
    //  V[gJbg̐ݒ
    FileName:= AFilePath;
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink := CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile := ShellLink as IPersistFile;
    with ShellLink do
    begin
        //  t@ČɎw肷p[^
        SetArguments('/starup');
        //  st@C̃tpX
        SetPath(PChar(FileName));
        //  ƃtH_
        SetWorkingDirectory(PChar(ExtractFileDir(FileName)));
    end;
    //  V[gJbgt@C̍쐬
    FileName := ChangeFileExt(ExtractFilename(FileName), '.lnk');
    LinkFileName := Format('%s\%s',[TargetPath, FileName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), False));
    //  ?
    Result := LinkFileName;
end;

(*
    =================================================================
    X^[gAbvJ
    -----------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    =================================================================
*)
procedure   OpenStartUp();
var
    TargetPath: string;
begin
    TargetPath := GetStartUpPath(); 
    if (TargetPath <> '') then
    begin
        SimpleShellExecute(TargetPath);
    end
    else
    begin
        Application.MessageBox('StartUp Not Found... (:<)', 'see you');
    end;
end;

(*
    =================================================================
    fXNgbvɃV[gJbg
    -----------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    =================================================================
*)
function    SendShortCutToDesktop(AFilePath: string): string;
var
    TargetPath: string;
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    FileName: String;
    LinkFileName: string;
    WFileName: WideString;
begin
    //  pX擾
    TargetPath := GetStartUpPath();
    //  v?
    Result := '';
    if (not DirectoryExists(TargetPath)) then Exit;
    //  V[gJbg̐ݒ
    FileName:= AFilePath;
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink := CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile := ShellLink as IPersistFile;
    with ShellLink do
    begin
        //  st@C̃tpX
        SetPath(PChar(FileName));
        //  ƃtH_
        SetWorkingDirectory(PChar(ExtractFileDir(FileName)));
    end;

    //  V[gJbgt@C̍쐬
    FileName := ChangeFileExt(ExtractFilename(FileName), '.lnk');
    LinkFileName := Format('%s\%s',[GetDesktopPath(), FileName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), False));
    //  ?
    Result := LinkFileName;
end;

(*
    =================================================================
    fXNgbv\
    -----------------------------------------------------------------
    http://homepage1.nifty.com/MADIA/vb/vb_bbs/200304_03040017.html
    http://www.elists.org/pipermail/delphi/2003-December/024919.html
    =================================================================
*)
procedure   ToggleDesktopNearly();
var
    Shell: OleVariant;
begin
    Shell := CreateOleObject('Shell.Application');
    Shell.MinimizeAll;
    Shell := Unassigned;
end;

(*
    =====================================================================
    ݔs
    =====================================================================
*)
procedure    SendToRecycleBin(FileName: string);
var
    SHF: TSHFileOpStruct;
begin
    with SHF do
    begin
        Wnd    := Application.Handle;
        wFunc  := FO_DELETE;
        pFrom  := PChar(FileName + #0);
        fFlags := FOF_ALLOWUNDO;
    end;
    SHFileOperation(SHF);
end;

end.

